

var statusFile = fb.ProfilePath + "pl_organizer.txt";  
if (utils.IsFile(statusFile) == false) {
	utils.WriteTextFile(statusFile, "");
}
var selected = {
	index: -1,
	pl: 0
}
var showNumb = true;
var units = ['bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
var VK_ADD = 0x6B;
var VK_SUBTRACT = 0x6D;
var g_wallpaperImg = null;
var VK_PRIOR = 0x21;
var VK_NEXT = 0x22;
var VK_END = 0x23;
var VK_HOME = 0x24;
var VK_LEFT = 0x25;
var VK_RIGHT = 0x27;

chars["state1"] = '\uF150';
chars["state2"] = '\uF152';
chars["body"] = '\uF007';
chars["pdf"] = '\uf1c1';
chars["weight"] = '\uf0a0';
chars["number"] = '\uf0cb';
chars["folder_close"] = '\uf07b';
chars["folder_open"] = '\uf07c';
chars["sound"] = '\uf001';



function _pl_organizer() {
	this.size = function () {
		this.panel_h = window.Height;
		this.panel_w = window.Width;
		this.w = window.Width - (LM * 2);
		this.h = window.Height - TM;
		this.rows = Math.floor((this.h - _scale(24)) / this.row_height);
		this.up_btn.x = this.off + Math.round((this.panel_w ) / 2);
		this.down_btn.x = this.up_btn.x;
		this.up_btn.y = this.y;
		this.down_btn.y = this.h;
		this.buttons_numb.x = this.panel_w  - 80;
		this.buttons_numb.h = 30;
		this.but_help.x = this.panel_w  - 45;
		
	}

	this.setSel = function (index) {
		selected.index = index;
		selected.pl = this.display[index].pl;
	}
	this.paint = function (gr) {
		if (this.items == 0) {
			return;
		}
		// Background
		if (this.bgpic && g_wallpaperImg) {
			gr.FillRectangle(0, 0, this.panel_w, this.panel_h, this.colours_background);
			gr.DrawImage(g_wallpaperImg, 0, 0, this.panel_w, this.panel_h, 0, 0, g_wallpaperImg.Width, g_wallpaperImg.Height, 0.1);
		}
		else
			gr.FillRectangle(0, 0, this.panel_w , this.panel_h, this.colours_background);
		// draw header
		gr.WriteText("# " + this.data.filter(function (artr) {
			return artr.pl == 1;
		}).length, this.fonts_folder, this.text_color, LM, 0 - 5, this.panel_w  - (LM * 2), TM, DWRITE_TEXT_ALIGNMENT_LEADING, DWRITE_PARAGRAPH_ALIGNMENT_CENTER, DWRITE_WORD_WRAPPING_NO_WRAP, DWRITE_TRIMMING_GRANULARITY_CHARACTER);
		gr.DrawLine(LM, TM + 0.5, this.panel_w - LM, TM + 0.5, 1, this.headerline_color); // this.colours.highlight);
		var col = this.text_color;
		//paint the list
		var playing_item_location = plman.GetPlayingItemLocation();
		for (var i = 0; i < Math.min(this.items, this.rows); i++) { 
			var fold_numbers = 0;
			var indent = this.display[i + this.offset].lvl * 20;
			if (this.display[i + this.offset].pl == 0) { // paint a folder
				var fold = this.display[i + this.offset].name;
				fold_numbers = this.data.filter(function (artr) { //count of playlists in that folder (from this.data because display have excluded them)
					return artr.fold == fold;
				}).length;
				var fold = (this.display[i + this.offset].foldState == '1' ? chars.folder_open : chars.folder_close);
				var font = this.foldertext_weight == 1 ? this.fonts_folder_bold : this.fonts_folder;
				gr.WriteText(fold, this.fonts.awesome, this.folderIcon_color, indent + this.off, this.ylist + _scale(8) + (i * this.row_height) + 5, this.calc_text_width(fold, this.fonts.awesome)+20, this.row_height);
				gr.WriteText(" " + this.display[i + this.offset].name + " [" + fold_numbers + "]", font , this.folder_color, indent + this.off + this.calc_text_width(fold, font) + 5, this.ylist + _scale(8) + (i * this.row_height), this.panel_w, this.row_height);
				var disp = this.display[i + this.offset].value.toString().replace(/\B(?=(\d{3})+(?!\d))/g, " ");
				gr.WriteText(disp, font, this.folder_color, this.w - this.calc_text_width(disp,font) -4, this.ylist + _scale(8) + (i * this.row_height), this.calc_text_width(disp, font) + 20, this.row_height);
			}
			else {
				// paint a playlist
				var disp;
				if (showNumb)
					disp = this.display[i + this.offset].value.toString().replace(/\B(?=(\d{3})+(?!\d))/g, " ");
				else disp = "#" + this.display[i + this.offset].value.toString().replace(/\B(?=(\d{3})+(?!\d))/g, " ") + " | " + niceBytes(this.display[i + this.offset].size);
				if (playing_item_location.IsValid) { // file played
					if (this.display[i + this.offset].name == plman.GetPlaylistName(playing_item_location.PlaylistIndex))
						if (this.activeSongOption)
							gr.WriteText(chars.sound, this.fonts.awesome, this.but_color, 5, this.ylist + _scale(8) + (i * this.row_height) + 3, 25, this.row_height);
						else col = this.activeSong_color;
				}
				gr.WriteText(this.display[i + this.offset].name, this.fonts_playlist, col, indent + this.off, this.ylist + _scale(8) + (i * this.row_height), this.panel_w, this.row_height);
				gr.WriteText(disp, this.fonts_playlist, col, this.w - this.calc_text_width(disp, this.fonts_playlist) - 4, this.ylist + _scale(8) + (i * this.row_height), this.calc_text_width(disp, this.fonts_playlist) +20, this.row_height);
				col = this.text_color;
			}
			// paint the active playlist
			if (plman.ActivePlaylist != -1) {
				if (plman.FindPlaylist(this.display[i + this.offset].name) == plman.ActivePlaylist)
					gr.DrawRectangle( this.off - 4, this.ylist + _scale(8) + (i * this.row_height) +1, this.w - this.off+7, this.row_height+2, 1, this.but_color); // -4 & +1 are there to hide the rectangle when selected
			}
		}

		if (selected.index > -1) {
			var indent = this.display[selected.index].lvl * 20;
			if (this.display[selected.index].pl == 0) { //paint a selected folder
				var fold = this.display[selected.index].name;
				fold_numbers = this.data.filter(function (artr) { //count of playlists in that folder (from this.data because display have excluded them)
					return artr.fold == fold;
				}).length;
				var disp = this.display[selected.index].value.toString().replace(/\B(?=(\d{3})+(?!\d))/g, " ");
				var fold = (this.display[selected.index].foldState == '1' ? chars.folder_open : chars.folder_close);
				var font = this.foldertext_weight == 1 ? this.fonts_folder_bold : this.fonts_folder;
				gr.fillrectangle( this.off - 5, this.ylist + _scale(8) + ((selected.index - this.offset) * this.row_height), this.w - this.off + 8, this.row_height + 3, this.selection_color);
				gr.WriteText(fold, this.fonts.awesome, this.folderIcon_color, indent + this.off, this.ylist + _scale(8) + ((selected.index - this.offset) * this.row_height) + 5, this.panel_w, this.row_height);
				gr.WriteText(" " + this.display[selected.index].name + " [" + fold_numbers + "]", font, this.folder_color, indent + this.off + this.calc_text_width(fold, font) + 5, this.ylist + _scale(8) + ((selected.index - this.offset) * this.row_height), this.panel_w, this.row_height);
				gr.WriteText(disp, font, this.folder_color, this.w - this.calc_text_width(disp, font) - 4, this.ylist + _scale(8) + ((selected.index - this.offset) * this.row_height), this.panel_w, this.row_height);
			}
			else { // paint a selected pl
				if (showNumb)
					disp = this.display[selected.index].value.toString().replace(/\B(?=(\d{3})+(?!\d))/g, " ");
				else disp = "#" + this.display[selected.index].value.toString().replace(/\B(?=(\d{3})+(?!\d))/g, " ") + " | " + niceBytes(this.display[selected.index].size);
				if (playing_item_location.IsValid) { // file played
					if (this.display[selected.index].name == plman.GetPlaylistName(playing_item_location.PlaylistIndex) && this.activeSongOption == 0)
						col = this.activeSong_color;
					else col = this.text_color;
				}
				gr.fillrectangle(this.off - 5, this.ylist + _scale(8) + ((selected.index - this.offset) * this.row_height), this.w - this.off + 8, this.row_height + 3, this.selection_color);
				gr.WriteText(this.display[selected.index].name, this.fonts_playlist, col, indent + this.off, this.ylist + _scale(8) + ((selected.index - this.offset) * this.row_height), this.panel_w, this.row_height);
				gr.WriteText(disp, this.fonts_playlist, col, this.w - this.calc_text_width(disp, this.fonts_playlist) - 4, this.ylist + _scale(8) + ((selected.index - this.offset) * this.row_height), this.calc_text_width(disp, this.fonts_playlist) + 20, this.row_height);
			}
		}
		if (this.dragDrop) { //if drag & drop
			gr.DrawRectangle(30, this.DragLineY, this.w - 25, this.DragLineH, 2, RGB(255, 0, 0));
		}
		if (this.inputboxID == 1) this.inputbox.draw(gr, 150, 0);
		
		this.up_btn.paint(gr, this.text_color, chars.up); 
		this.down_btn.paint(gr, this.text_color, chars.down);
		this.buttons_numb.paint(gr, this.but_color, showNumb ? chars.weight : chars.number);
		this.but_help.paint(gr, this.but_color);
	//	this.inputSearchBut.paint(gr, this.text_color);
	}


	this.containsXY = function (x, y) {
		return x > this.off && x < this.panel_w && y > this.y && y < this.panel_h;
	}

	this.wheel = function (s) {
		if (this.items > this.rows) {
			var offset = this.offset - (s * 3);
			if (offset < 0) {
				offset = 0;
			}
			if (offset + this.rows > this.items) {
				offset = this.items - this.rows;
			}
			if (this.offset != offset) {
				this.offset = offset;
				window.Repaint();
			}
		}
		else this.offset = 0;
	return true;
	}

	this.lbtn_dblck = function (x, y) {
		if (this.containsXY(x, y)) {
			switch (true) {
				case this.up_btn.lbtn_up(x, y):
				case this.down_btn.lbtn_up(x, y):
				case this.buttons_numb.lbtn_up(x, y): //
				case this.but_help.lbtn_up(x, y):
			//	case this.inputSearchBut.lbtn_up(x,y):
				case !this.in_range:
					break;
				// BELOW TO Double CLICK ON AN ITEM
				case x > this.off && x < this.panel_w :
					if (this.display[this.index].pl == 0) {//folder
						if (this.display[this.index].foldState == '1' ) this.display[this.index].foldState = '0';
						else {
							if (this.autocollapse && this.display[this.index].lvl == '0') {
								for (var i = 0; i < this.data.length; i++) {
									if (this.data[i].foldState == '1' && this.data[i].lvl == '0') this.data[i].foldState = '0';
								}
							}
							this.display[this.index].foldState = '1';
						}
					}
					else {
						plman.ActivePlaylist = plman.FindPlaylist(this.display[this.index].name);
					}
					this.cleanup();
					this.setSel(this.index);
					this.wheel(0);
					window.RepaintRect(0, this.ylist, this.w, this.h);
					break;
			}
			return true;
		}
		return false;
	}


	this.move = function (x, y) {
	//	this.mx = x;
	//	this.my = y;
		window.SetCursor(IDC_ARROW);
		if (this.containsXY(x, y)) {
			this.index = Math.floor((y - this.ylist - _scale(8)) / this.row_height) + this.offset;
			this.in_range = this.index >= this.offset && this.index < this.offset + Math.min(this.rows, this.items);
			switch (true) {
				case this.up_btn.move(x, y):
				case this.down_btn.move(x, y):
				case this.buttons_numb.move(x, y):
				case this.but_help.move(x, y):
			//	case this.inputSearchBut.move(x, y):
					break;
				case !this.in_range:
					break;
				case x > this.off && x < this.panel_w :
					window.SetCursor(IDC_HAND);
					if (this.btnDown && Math.abs(this.dragy - y) > 2) {
						if (this.index + 1 - this.offset == this.rows) this.offset = Math.min(this.offset + 1, (this.items - this.rows)); // boundary down
						if (this.index - this.offset == 0) this.offset = Math.max(this.offset - 1, 0);  // boundary up
						var to = (this.row_height * (this.index - this.offset + 1)) + this.ylist + _scale(8);
						var from = to - this.row_height;
						window.SetCursor(IDC_HELP);
						switch (true) {
							case y >= from && y < from + 7:
								window.SetCursor(IDC_HAND);
								this.dragDrop = true;
								this.DragLineY = from;
								this.DragLineH = 0;
								_tt("Dragging " + this.display[this.draggedIndex].name + " before " + this.display[this.index].name);
								if (this.draggedIndex < this.droppedIndex) this.droppedIndex = this.index - 1; else this.droppedIndex = this.index;
								break;
							case y < to && y > to - 7:
								window.SetCursor(IDC_HAND);
								this.dragDrop = true;
								this.DragLineY = to;
								this.DragLineH = 0;
								_tt("Dragging " + this.display[this.draggedIndex].name + " after " + this.display[this.index].name); // ?
								if (this.draggedIndex < this.droppedIndex) this.droppedIndex = this.index; else this.droppedIndex = this.index + 1;
								break;
							case y > from + 7 && y < to - 7 && this.display[this.index].pl == '0' && this.display[this.index].id !== this.display[this.draggedIndex].id:
								window.SetCursor(IDC_HAND);
								this.dragDrop = true;
								this.DragLineY = from;
								this.DragLineH = this.row_height;
								_tt("Dropping " + this.display[this.draggedIndex].name + " in the folder " + this.display[this.index].name); // ?
								this.droppedIndex = this.index;
								break;
							default:
								this.dragDrop = false;
								_tt('');
								break;
						}
						window.repaint();
					}
					else
						this.display[this.index].pl == 1 ? _tt('Total : ' + millisecondsToStr(plman.GetPlaylistItems(plman.FindByGUID(this.display[this.index].id)).CalcTotalDuration())) : _tt('');
			}
			return true;
		}
		return false;
	}
	this.lbtn_down = function (x, y) {
		if (this.containsXY(x, y)) {
			this.dragy = y;
			this.btnDown = true;
		}
		if (this.containsXY(x, y)) {
			switch (true) {
				case this.up_btn.lbtn_up(x, y):
				case this.down_btn.lbtn_up(x, y):
				case this.buttons_numb.lbtn_up(x, y):
				case this.but_help.lbtn_up(x, y):
			//	case this.inputSearchBut.lbtn_up(x, y):
				case !this.in_range:
					break;
				case x >  this.off && x < this.panel_w :
					this.draggedIndex = this.index;
					break;
			}
			return true;
		}
		return false;
	}


	this.lbtn_up = function (x, y) {
		this.btnDown = false;
		if (this.dragDrop) {
			indexDrop = _.findIndex(this.data, { id: this.display[this.droppedIndex].id });
			id = this.display[this.draggedIndex].id;
			indexDrag = _.findIndex(this.data, { id: id });
			if (this.DragLineH == 0) { // not a folder
				if (this.display[this.draggedIndex].lvl != this.display[this.droppedIndex].lvl) {
					this.data[indexDrag].fold = this.display[this.droppedIndex].fold;
					this.data[indexDrag].lvl = this.display[this.droppedIndex].lvl;
				}
				this.data.move(_.findIndex(this.data, { id: this.display[this.draggedIndex].id }), _.findIndex(this.data, { id: this.display[this.droppedIndex].id }));
			}
			else { //a folder
				this.data[indexDrag].fold = this.data[indexDrop].name;
				this.data[indexDrag].lvl = Number(this.data[indexDrop].lvl) + 1;
			}
			this.dragDrop = false;
			this.countFold();
			this.cleanup();
			if (this.display[this.droppedIndex].foldState == '0') // if folder is closed then select it otherwise, select the dropped PL
				this.setSel(this.droppedIndex);
			else {
				this.setSel(_.findIndex(this.display, { id: id }));
			}
			this.wheel(0);
			window.repaint();
		}
		else {
			if (this.containsXY(x, y)) {
				switch (true) {
					case this.up_btn.lbtn_up(x, y):
					case this.down_btn.lbtn_up(x, y):
					case !this.in_range:
						break;
					case x > this.off && x < this.panel_w : // TO CLICK ON AN ITEM
						if (this.openPLclick == 0 && this.display[this.index].pl == 1)
							plman.ActivePlaylist = plman.FindByGUID(this.display[this.index].id); 
						this.setSel(this.index);
						window.RepaintRect(0, this.ylist, this.panel_w , this.h);
						break;
				}
				return true;
			}
		}
		return false;
	}
	this.on_drag_over = function (action, x, y, mask) {
		if (this.containsXY(x, y)) {
			this.index = Math.floor((y - this.ylist - _scale(8)) / this.row_height) + this.offset;
			this.in_range = this.index >= this.offset && this.index < this.offset + Math.min(this.rows, this.items);
			switch (true) {
				case !this.in_range:
					break;
				case x > this.off && x < this.panel_w :
					if (this.display[this.index].pl == 1 && !plman.IsAutoPlaylist(plman.FindByGUID(this.display[this.index].id))) {
						action.Effect = 1;
					}
					else
						action.Effect = 0;
			}
		}
	}
	this.on_drag_drop = function (action, x, y, mask) {
		if (this.containsXY(x, y)) {
			this.index = Math.floor((y - this.ylist - _scale(8)) / this.row_height) + this.offset;
			this.in_range = this.index >= this.offset && this.index < this.offset + Math.min(this.rows, this.items);
			switch (true) {
				case !this.in_range:
					break;
				case x > this.off && x < this.panel_w :
					if (this.display[this.index].pl == 1 && !plman.IsAutoPlaylist(plman.FindByGUID(this.display[this.index].id))) {
						var ap = plman.FindByGUID(this.display[this.index].id);
						action.Playlist = ap;
						action.Base = plman.GetPlaylistItemCount(ap);
						action.ToSelect = true;
						action.Effect = 1;
						window.repaint();
					}
					break;
			}
		}
    }

	this.PLmgt = function (i) {
		
		var id = _.findIndex(this.data, { id: plman.GetGUID(i) })
		this.data[id].value = plman.GetPlaylistItemCount(i);
		this.data[id].size = plman.GetPlaylistItems(i).CalcTotalSize();
		window.repaint();
    }

	this.rbtn_up = function (x, y) {
		if (this.containsXY(x, y)) {
			switch (true) {
				case this.up_btn.lbtn_up(x, y):
				case this.down_btn.lbtn_up(x, y):
				case this.buttons_numb.lbtn_up(x, y):
				case this.but_help.lbtn_up(x, y):
				//case this.inputSearchBut.lbtn_up(x, y):
					break;
				case x > this.off && x < this.panel_w  && y <= this.ylist:
					this.customMenu(x, y);
					break;
				case x > this.off && x < this.panel_w  && y > this.ylist:
					this.contextMenu(x, y);
					break;
			}
			return true;
		}
		return false;
	}

	this.customMenu = function (x, y) {
		this.s = window.CreatePopupMenu();
		this.l1 = window.CreatePopupMenu();
		this.l2 = window.CreatePopupMenu();
		this.l3 = window.CreatePopupMenu();
		this.l4 = window.CreatePopupMenu();
		this.l5 = window.CreatePopupMenu();
		this.l6 = window.CreatePopupMenu();
		this.l7 = window.CreatePopupMenu();
		this.l8 = window.CreatePopupMenu();
		this.l9 = window.CreatePopupMenu();
		this.s.AppendMenuItem(CheckMenuIf(this.autocollapse), 1050, 'Auto-Collapse');
		this.s.AppendMenuSeparator();
		this.l1.AppendTo(this.s, MF_STRING, 'Background');
		this.l1.AppendMenuItem(CheckMenuIf(this.bgpic), 1060, 'set background to front cover');
		this.l1.AppendMenuItem(CheckMenuIf(!this.bgpic), 1061, 'set background to color ...');
		this.l1.AppendMenuItem(MF_STRING, 1062, 'set background to default');
		this.s.AppendMenuItem(MF_STRING, 1070, 'Buttons color ...');
		this.s.AppendMenuItem(MF_STRING, 1075, 'Header line color ...');
		this.l2.AppendTo(this.s, MF_STRING, 'Text');
		if (this.list_objects.length || this.text_objects.length) {
			_.forEach(this.fonts_sizes, function (item) {
				this.l4.AppendMenuItem(MF_STRING, item, item);
			}, this);
			this.l4.CheckMenuRadioItem(_.first(this.fonts_sizes), _.last(this.fonts_sizes), this.fontSize_value);
			this.l4.AppendTo(this.l2, MF_STRING, 'Font size');
			this.s.AppendMenuSeparator();
		}
		this.l2.AppendMenuItem(MF_STRING, 1081, 'Playlist Color...');
		this.l2.AppendMenuItem(MF_STRING, 1082, 'Folder Color...');
		this.l2.AppendMenuItem(MF_STRING, 1083, 'Set Text color to default');
		this.l8.AppendTo(this.l2, MF_STRING, 'Folder Icon color ...');
		this.l8.AppendMenuItem(MF_STRING, 1084, 'Folder Icon color ...');
		this.l8.AppendMenuItem(MF_STRING, 1085, 'Set Folder icon color to default');
		this.l9.AppendTo(this.l2, MF_STRING, 'Folder text weight');
		this.l9.AppendMenuItem(MF_STRING, 1086, 'Normal');
		this.l9.AppendMenuItem(MF_STRING, 1087, 'Bold');
		this.l9.CheckMenuRadioItem(1086, 1087, this.foldertext_weight + 1086); 
		this.l3.AppendTo(this.s, MF_STRING, 'Selection bar');
		this.l3.AppendMenuItem(MF_STRING, 1088, 'Selection Bar color ...');
		this.l3.AppendMenuItem(MF_STRING, 1089, 'Set Selection Bar to default ...');
		this.l5.AppendTo(this.s, MF_STRING, 'Open playlist ');
		this.l5.AppendMenuItem(MF_STRING, 1091, 'Single Click');
		this.l5.AppendMenuItem(MF_STRING, 1092, 'Double Click');
		this.l5.CheckMenuRadioItem(1091, 1092, this.openPLclick + 1091); 
		this.l6.AppendTo(this.s, MF_STRING, 'Delete Key ');
		this.l6.AppendMenuItem(MF_STRING, 1095, 'Disabled');
		this.l6.AppendMenuItem(MF_STRING, 1096, 'Enabled');
		this.l6.CheckMenuRadioItem(1095, 1096, this.delOption + 1095); 
		this.l7.AppendTo(this.s, MF_STRING, 'Active Song Sign');
		this.l7.AppendMenuItem(MF_STRING, 1098, 'Color...');
		this.l7.AppendMenuItem(MF_STRING, 1099, 'Icon on the left');
		this.l7.CheckMenuRadioItem(1098, 1099, this.activeSongOption + 1098); 

		this.s.AppendMenuItem(MF_STRING, 2000, 'Configure...');

		this.s.AppendMenuSeparator();
		
		var idx = this.s.TrackPopupMenu(x, y);
		switch (true) {
			case idx <= 32 && idx >0 :
				this.fontSize_value = idx;
				this.font_changed();
				this.size();
				window.SetProperty("PL.FONTSIZE.VALUE", this.fontSize_value);
				window.Repaint();
				break;
			case idx == 1050: //auto collapse
				if (this.autocollapse == false) {
					for (var i = 0; i < this.data.length; i++) {
						if (this.data[i].foldState == '1' && this.data[i].lvl == '0') this.data[i].foldState = '0';
					}
				}
				this.cleanup();
				window.Repaint();
				this.autocollapse = !this.autocollapse;
				window.SetProperty("PL.AUTOCOLLAPSE.BOOL", this.autocollapse);
				break;
			case idx == 1060:
				this.bgpic = !this.bgpic;
				window.SetProperty("PL.BACKGROUNDPIC.BOOL", this.bgpic);
				this.setBkgroundImg();
				window.repaint();
				break;
			case idx == 1061:
				this.bgpic = false;
				this.colours_background = utils.ColourPicker(this.colours_background);
				window.SetProperty("PL.BACKGROUNDPIC.BOOL", this.bgpic);
				window.SetProperty("PL.BACKGROUND.COLOR", this.colours_background);
				window.repaint();
				break;
			case idx == 1062:
				this.bgpic = false;
				if (window.IsDefaultUI) this.colours_background = window.GetColourDUI(1);
				else this.colours_background = window.GetColourCUI(3);
				window.SetProperty("PL.BACKGROUNDPIC.BOOL", this.bgpic);
				window.SetProperty("PL.BACKGROUND.COLOR", this.colours_background);
				window.repaint();
				break;
			case idx == 1070:
				this.but_color = utils.ColourPicker(this.but_color);
				window.SetProperty("PL.BUTTONS.COLOR", this.but_color);
				window.repaint();
				break;
			case idx == 1075:
				this.headerline_color = utils.ColourPicker(this.headerline_color);
				window.SetProperty("PL.HEADERLINE.COLOR", this.headerline_color);
				window.repaint();
				break;

			case idx == 1081:
				this.text_color = utils.ColourPicker(this.text_color);
				window.SetProperty("PL.TEXT.COLOR", this.text_color);
				window.repaint();
				break;
			case idx == 1082:
				this.folder_color = utils.ColourPicker(this.text_color);
				window.SetProperty("PL.FOLDER.COLOR", this.folder_color);
				window.repaint();
				break;
			case idx == 1083:
				if (window.IsDefaultUI) this.text_color = window.GetColourDUI(0);
				else this.text_color = window.GetColourCUI(0);
				this.folder_color = this.text_color;
				window.SetProperty("PL.TEXT.COLOR", this.text_color);
				window.SetProperty("PL.FOLDER.COLOR", this.folder_color);
				window.repaint();
				break;
			case idx == 1084:
				this.folderIcon_color = utils.ColourPicker(this.folderIcon_color);
				window.SetProperty("PL.FOLDERICON.COLOR", this.folderIcon_color);
				window.repaint();
				break;
			case idx == 1085:
				this.folderIcon_color = this.text_color;
				window.SetProperty("PL.FOLDERICON.COLOR", this.folderIcon_color);
				window.repaint();
				break;
			case idx == 1086:
				this.foldertext_weight = 0; //normal
				window.SetProperty("PL.FOLDERTEXT.WEIGHT", this.foldertext_weight);
				window.repaint();
				break;
			case idx == 1087:
				this.foldertext_weight = 1; //bold
				window.SetProperty("PL.FOLDERTEXT.WEIGHT", this.foldertext_weight);
				window.repaint();
				break;
			case idx == 1088:
				this.selection_color = utils.ColourPicker(this.selection_color);
				window.SetProperty("PL.SELECTION.COLOR", this.selection_color);
				window.repaint();
				break;
			case idx == 1089:
				this.selection_color = RGB(62, 87, 109);
				window.SetProperty("PL.SELECTION.COLOR", this.selection_color);
				window.repaint();
				break;
			case idx == 1091:
				this.openPLclick = 0;
				window.SetProperty("PL.PLCLICK.BOOL", this.openPLclick);
				break;
			case idx == 1092:
				this.openPLclick = 1;
				window.SetProperty("PL.PLCLICK.BOOL", this.openPLclick);
				break;
			case idx == 1095:
				this.delOption = 0;
				window.SetProperty("PL.DELOPTION.BOOL", this.delOption);
				break;
			case idx == 1096:
				this.delOption = 1;
				window.SetProperty("PL.DELOPTION.BOOL", this.delOption);
				break;
			case idx == 1098:
				this.activeSongOption  = 0;
				window.SetProperty("PL.ACTIVESONG.BOOL", this.activeSongOption);
				this.activeSong_color = utils.ColourPicker(this.activeSong_color);
				window.SetProperty("PL.ACTIVESONG.COLOR", this.activeSong_color);
				this.off = 5;
				window.repaint();
				break;
			case idx == 1099:
				this.activeSongOption = 1;
				window.SetProperty("PL.ACTIVESONG.BOOL", this.activeSongOption);
				this.off = 35;
				window.repaint();
				break;
			case idx == 2000:
				window.ShowConfigure();
				break;
		}
		_dispose(this.s, this.l1, this.l2, this.l3, this.l4, this.l5, this.l6, this.l7, this.l8, this.l9);
    }

	this.contextMenu = function (x, y) {

		this.s = window.CreatePopupMenu();
		this.l1 = window.CreatePopupMenu();
		this.s.AppendMenuItem(EnableMenuIf(selected.index > -1), 1100, 'Move up \t+');
		this.s.AppendMenuItem(EnableMenuIf(selected.index > -1), 1200, 'Move down\t-');
		this.s.AppendMenuSeparator();
		this.s.AppendMenuItem(EnableMenuIf(selected.index > -1 && selected.pl == 1 && plman.IsAutoPlaylist(plman.FindByGUID(this.display[selected.index].id))), 1300, 'AutoPlaylist...');
		this.s.AppendMenuItem(EnableMenuIf(selected.index > -1), 1400, 'Rename ' + (selected.pl == 1 ? 'Playlist...' : 'Folder...'));
		this.s.AppendMenuSeparator();
		var filt = "";
		if (selected.index > -1) {
			if (selected.pl == 1) filt = this.display[selected.index].fold;
			else filt = this.display[selected.index].name;
		}
		this.s.AppendMenuItem(EnableMenuIf(selected.index > -1), 1450, 'Filter (Asc) on folder : "' + (filt == "" ? 'Root' : filt) + '"');
		this.s.AppendMenuItem(EnableMenuIf(selected.index > -1), 1460, 'Filter (Desc) on folder : "' + (filt == "" ? 'Root' : filt) + '"');
		this.s.AppendMenuSeparator();
		this.s.AppendMenuItem(MF_STRING, 1500, 'Create folder...');
		this.s.AppendMenuItem(MF_STRING, 1600, 'Create AutoPlaylist');
		this.s.AppendMenuItem(MF_STRING, 1630, 'Create Playlist');
		this.s.AppendMenuItem(EnableMenuIf(selected.index > -1 && selected.pl == 1), 166, 'Convert into a regular playlist');
		this.s.AppendMenuItem(EnableMenuIf(selected.index > -1), 1700, 'Delete ' + (selected.pl == 1 ? 'Playlist...' : 'Folder...') + '\tDel');
		this.s.AppendMenuSeparator();
		this.s.AppendMenuItem(EnableMenuIf(selected.index > -1 && this.display[selected.index].lvl > 0 && selected.pl == 1), 1800, 'Put at root');
		this.ctrl ? this.Folder = this.data.filter(function (artr) {
			return artr.pl == '0' && artr.lvl == '0';
		}) : this.Folder = this.data.filter(function (artr) {
			return artr.pl == '0';
		});
			if (this.Folder.length) {
				this.l1.AppendTo(this.s, EnableMenuIf(selected.pl == 1), 'Move Playlist into ... \tCtrl for root');
				for (var i = 0; i < this.Folder.length; i++) {
					arr = [];
					for (var j = 0; j < this.Folder.length; j++) {
						if (this.Folder[j].fold == this.Folder[i].name && this.Folder[j].lvl == '1')
							arr.push(this.Folder[j]);
					}
					if (arr.length) {
						this["menu" + j] = window.CreatePopupMenu(); // how to dispose these menus ?
						this["menu" + j].AppendTo(this.l1, MF_STRING, this.Folder[i].name);
						for (var k = 0; k < arr.length; k++) {
							this["menu" + j].AppendMenuItem(MF_STRING, _.findIndex(this.data, { id: arr[k].id }) + 2000, arr[k].name);
						}
					}
					else if (this.Folder[i].lvl == '0') { this.l1.AppendMenuItem(MF_STRING, _.findIndex(this.data, { id: this.Folder[i].id }) + 2000, this.Folder[i].name); }
				}
		}
		if (selected.index > -1) {
			this.s.AppendMenuSeparator(); // context menu
			this._items = window.CreatePopupMenu();
			this._context = fb.CreateContextMenuManager();
			var playlist_items = plman.GetPlaylistItems(plman.FindByGUID(this.display[selected.index].id));
			if (playlist_items.Count > 0) {
				this.s.AppendMenuSeparator();
				this._context.InitContext(playlist_items);
				this._context.BuildMenu(this._items, 10000);
				this._items.AppendTo(this.s, MF_STRING, 'Items');
			}
		}
			this.s.AppendMenuSeparator();
			var idx = this.s.TrackPopupMenu(x, y);
			switch (true) {
				
				case idx == 1100: //move up
					this.moveUD('up');
					break;
				case idx == 1200: //move down
					this.moveUD('down');
					if (selected.index - this.offset == this.rows) this.offset++;
					break;
				case idx == 1300:
					plman.ShowAutoPlaylistUI(plman.FindByGUID(this.display[selected.index].id));
					break;
				case idx == 1400: // rename a playlist
					try {
						value = utils.InputBox("Give a new name to this playlist", "Rename Playlist", this.display[selected.index].name);
					} catch (e) { return; }
					if (value) {
						if (this.display[selected.index].pl == 1)
							plman.RenamePlaylist(plman.FindByGUID(this.display[selected.index].id), value);
						var ind = _.findIndex(this.data, { id: this.display[selected.index].id });
						for (var i = 0; i < this.data.length; i++) {
							if (this.data[i].fold == this.data[ind].name) this.data[i].fold = value;
						}
						this.data[ind].name = value;
						this.cleanup();
						window.Repaint();
					}
					break;
				case idx == 1450:
					this.data.sort(function (a, b) {
						if (a.fold == filt) {
							var aname = a.name.toLowerCase();
							var bname = b.name.toLowerCase();
							if (aname < bname) {
								return -1;
							}
							if (aname > bname) {
								return 1;
							}
                        }
					});
					this.cleanup();
					window.Repaint();
					break;
				case idx == 1460:
					this.data.sort(function (a, b) {
						if (a.fold == filt) {
							var aname = a.name.toLowerCase();
							var bname = b.name.toLowerCase();
							if (aname < bname) {
								return 1;
							}
							if (aname > bname) {
								return -1;
							}
						}
					});
					this.cleanup();
					window.Repaint();
					break;
				case idx == 1500: //create a folder
					try {
						name = utils.InputBox("Input name of the new folder", "Create Folder", "New folder");
					} catch (e) { return; }
					if (name) {
						if (_.findIndex(this.data, { name: name }) == -1) {
							var ind = _.findIndex(this.data, { id: this.display[selected.index].id });
							this.data.splice(ind, 0, {
								"position": selected.index,
								"name": name,
								"value": '0',
								"pl": '0',
								"lvl": Number(this.display[selected.index].lvl),
								"fold": this.display[selected.index].fold,
								"foldState": '0',
								id: ++this.foldCount,
							});

							this.cleanup();
							this.wheel(0);
							window.Repaint();
						}
						else
							utils.MessageBox("You can't create a folder which name : " + name + " already exists", "Warning", MB_OK);
					}
					break;
				case idx == 1600: //create autoplaylist
					try {
						name = utils.InputBox("Input name of the new Autoplaylist", "Create AutoPlaylist");
					} catch (e) { return; }
					if (name) {
						var newind = plman.CreateAutoPlaylist(plman.PlaylistCount, name, "enter your query here");
						plman.ActivePlaylist = newind;
						plman.ShowAutoPlaylistUI(newind);
					}
					break;
				case idx == 1630: // create playlist
					try {
						name = utils.InputBox("Input name of the new playlist", "Create Playlist");
					} catch (e) { return; }
					if (name) {
						var newind = plman.CreatePlaylist(plman.PlaylistCount, name);
						plman.ActivePlaylist = newind;
					}
					break;

				case idx == 1660: // convert into a regular playlist
					var newind = plman.DuplicatePlaylist(plman.FindByGUID(this.display[selected.index].id), this.display[selected.index].name);
					plman.RemovePlaylist(plman.FindByGUID(this.display[selected.index].id));
					this.data[_.findIndex(this.data, { id: this.display[selected.index].id })].id = plman.GetGUID(newind);
					plman.ActivePlaylist = newind;
					break;
				case idx == 1700: // delete PL or folder
					this.delete();
					this.countFold();
					this.cleanup();
					this.wheel(0);
					window.Repaint();
					break;
				case idx == 1800: // Unfolderize playlist
					this.display[selected.index].lvl = '0';
					this.display[selected.index].fold = '';
					this.countFold();
					this.cleanup();
					this.wheel(0);
					window.Repaint();
					break;
				case idx >= 2000 && idx <= 2000 + this.data.length:
					var ind = _.findIndex(this.data, { id: this.display[selected.index].id });
					this.data[ind].lvl = Number(this.data[idx - 2000].lvl) + 1;  // increment the level from the folder
					this.data[ind].fold = this.data[idx - 2000].name;
					selected.index = -1;
					this.countFold();
					this.cleanup();
					this.wheel(0);
					window.Repaint();
					break;
				case idx >= 10000:
					this._context.ExecuteByID(idx - 10000);
					break;
			}
			_dispose(this.s, this.l1, this._items, this._context);
		}

	this.key_up = function (k) {
		switch (k) {
			case VK_CONTROL:
				this.ctrl = false;
				break;

		}
	}

	this.key_down = function (k) {
		if (this.inputboxID == 1) {
			if (k == VK_SHIFT) {
				this.inputboxID = -1; window.repaint();
			}
			this.inputbox.on_key_down(k);
		}
		else {
			switch (k) {
				case VK_HOME:
					selected.index = 0;
					this.setSel(selected.index);
					this.offset = 0;
					window.Repaint();
					break;
				case VK_END:
					selected.index = this.items - 1;
					this.setSel(selected.index);
					this.offset = this.items - this.rows;
					window.Repaint();
					break;
				case VK_UP:
					if (selected.index !== -1 && selected.index !== 0) {
						selected.index--;
						this.setSel(selected.index);
						if (selected.index - this.offset == -1) this.offset--;
						window.Repaint();
					}
					break;
				case VK_DOWN:
					if (selected.index !== -1 && selected.index !== this.items - 1) {
						selected.index++;
						this.setSel(selected.index);
						if (selected.index - this.offset == this.rows) this.offset++;
						window.Repaint();
					}
					break;
				case VK_PRIOR:
					if (selected.index + 2 >= this.rows) {
						selected.index = selected.index - this.rows - 2;
						this.setSel(selected.index);
						if (selected.index < this.rows - 2) {
							this.offset = 0;
						} else {
							this.offset = selected.index;
						}
						window.Repaint();
					} else {
						selected.index = 0;
						this.setSel(selected.index);
						this.offset = 0;
						window.Repaint();
					}
					break;
				case VK_NEXT:
					if (selected.index <= this.items - this.rows - 3) {
						if (selected.index == 0) {
							selected.index = selected.index + this.rows + 2;
						} else {
							selected.index = selected.index + this.rows - 1;
						}
						this.setSel(selected.index);
						if (this.data.length - this.rows - 3 <= selected.index) {
							this.offset = this.items - this.rows;
						} else {
							this.offset = selected.index;
						}
						window.Repaint();
					} else {
						selected.index = this.items - 1;
						this.setSel(selected.index);
						this.offset = this.items - this.rows;
						window.Repaint();
					}
					break;
				case VK_LEFT:
					if ((selected.pl == 0) && (this.display[selected.index].foldState == 1)) {
						this.display[selected.index].foldState = 0;
					} else if (this.display[selected.index].lvl > 0 && selected.pl == 1) {
						while (selected.index > 0) {
							if (this.display[selected.index].pl == 0) {
								this.setSel(selected.index);
								if (selected.index - this.offset <= 0) {
									this.offset = selected.index;
								}
								window.Repaint();
								break;
							} else {
								selected.index--;
							}
						}
					}
					this.cleanup();
					window.Repaint();
					break;
				case VK_RIGHT:
					if ((selected.pl == 0) && (this.display[selected.index].foldState == 0)) {
						this.display[selected.index].foldState = 1;
						this.cleanup();
						window.Repaint();
					}
					break;
				case VK_DELETE:
					if (this.delOption)
						this.delete();
					else console.log("Delete Key is disabled");
					break;
				case VK_SUBTRACT:
					this.moveUD('up');
					break;
				case VK_ADD:
					this.moveUD('down');
					break;
				case VK_RETURN:
					if (selected.pl != 0) {
						plman.ActivePlaylist = plman.FindPlaylist(this.display[selected.index].name);
					}
					window.Repaint();
					break;
				case VK_CONTROL:
					this.ctrl = true;
					break;
				case VK_SHIFT:
					this.searchbox();
					break;
				default:
					return false;
			}
		}
	}

	this.moveUD = function (direction) {
		if (selected.index !== -1) {
			var from = _.findIndex(this.data, { id: this.display[selected.index].id });
			direction == 'up' ? to = from - 1 : to = from + 1;
			var id = this.data.move(from, to);
			this.cleanup();
			this.setSel(_.findIndex(this.display, { id: id }));
			if (selected.index - this.offset == -1) this.offset--; else if (selected.index - this.offset == this.rows) this.offset++;
			window.Repaint();
		}
	}

	this.delete = function () {
		if (selected.index !== -1) {
			if (selected.pl == 1) { plman.RemovePlaylist(plman.FindByGUID(this.display[selected.index].id)); }
			else { // delete folder
				for (var i = 0; i < this.data.length; i++) {
					if (this.data[i].fold == this.display[selected.index].name) {
						this.data[i].fold = '';
						this.data[i].lvl = '0';
						// playlist contained in the deleted folder falls into the mother folder
					}
				}
			}
			var index = _.findIndex(this.data, { id: this.display[selected.index].id });
			this.data.splice(index, 1); //delete
			this.countFold();
			this.cleanup();
			this.setSel(Math.max(0, Math.min(this.items - 1, selected.index--)));
			this.wheel(0);
			window.Repaint();
		}
	}

	this.setBkgroundImg = function () {
		if (g_wallpaperImg) {
			g_wallpaperImg.Dispose();
			g_wallpaperImg = null;
		}
		if (this.bgpic && fb.IsPlaying) {
			var metadb = fb.GetNowPlaying();
			if (metadb) var tmp = metadb.GetAlbumArt();
			if (tmp) g_wallpaperImg = metadb.GetAlbumArt();
		}
	}

	this.countFold = function () {
		for (var i = 0; i < this.data.length; i++) {
			if (this.data[i].pl == '0') { // folder
				var tot = 0;
				for (var j = 0; j < this.data.length; j++) {
					if (this.data[j].fold == this.data[i].name)
						tot = tot + Number(this.data[j].value);
					this.data[i].value = tot;
				}
			}
		}
	}
	this.save_status = function () { // Save latest to file
		strContents = "FORMAT : position;name;#files in PL (-1 if folder);playlist (yes = 1);lvl;folder name (if any) belonged to;folder status (1 = open)" + "\n";
		for (var i = 0; i < this.data.length; i++) {
			strContents = strContents + this.data[i].position + ";" + this.data[i].name + ";" + this.data[i].value + ";" + this.data[i].pl + ";" + this.data[i].lvl + ";" + this.data[i].fold + ";" + this.data[i].foldState + "\n";
		}
		_save(statusFile, strContents);
	}

	this.getFileData = function () { //get file archived status
		var text = utils.ReadUTF8(statusFile);
		var arr = text.split(/\r?\n/)
		dataFile = [];
		for (var i = 1; i < arr.length; i++) {
			var fields = arr[i].split(';');
			dataFile.push({
				"position": fields[0],
				"name": fields[1],
				"value": fields[2],
				"pl": fields[3],
				"lvl": fields[4],
				"fold": fields[5],
				"foldState": fields[6],
			});
		}
		this.BuildData(dataFile);
	}
	this.BuildData = function (dataFile) { // merge file situation to current playlist array (this.data)
		var temparr = [];
		// get positions & lvls
		for (var i = 0; i < this.data.length; i++) {
			var index = _.findIndex(dataFile, { name: this.data[i].name })
			if (index != -1) {
				this.data[i].position = dataFile[index].position;//index;
				this.data[i].pl = dataFile[index].pl;
				this.data[i].lvl = dataFile[index].lvl;
				this.data[i].fold = dataFile[index].fold;
				this.data[i].foldState = dataFile[index].foldState;
			}
			else {
				temparr.push(i);
			}
		}
		// integrate new playlist (not created through this this.panel_w ith default values
		if (temparr.length != 0) {
			for (var i = 0; i < temparr.length; i++) {
				this.data[temparr[i]].position = this.data.length - temparr.length + i;
				this.data[temparr[i]].pl = '1';
				this.data[temparr[i]].lvl = '0';
			}
		}
		// folders to integrate
		var dataFileFolder = dataFile.filter(function (artr) {
			return artr.pl == '0';
		});
		if (dataFileFolder.length) {
			for (var i = 0; i < dataFileFolder.length; i++) {
				dataFileFolder[i].id = ++this.foldCount;
				this.data.push(dataFileFolder[i]);
			}
		}
		this.data.sort(dynamicSort("position")); // ne trie pas par chiffre mais par texte a comparer  l'autre plus bas (je crois)
	}

	this.getData = function () {  	// get current playlists
		var data = [];
		for (var i = 0; i < plman.PlaylistCount; i++) {
			data.push({
				name: plman.GetPlaylistName(i),
				value: plman.GetPlaylistItemCount(i),
				position: '0',
				pl: '0',
				lvl: '0',
				fold: "",
				foldState: '',
				size: plman.GetPlaylistItems(i).CalcTotalSize(),
				id: plman.GetGUID(i),
			});
		}
		return data;
	}
	this.getStoredValues = function () {
		this.bgpic = window.GetProperty("PL.BACKGROUNDPIC.BOOL", 1);
		this.autocollapse = window.GetProperty("PL.AUTOCOLLAPSE.BOOL", false);
		this.but_color = window.GetProperty("PL.BUTTONS.COLOR", RGB(255, 255, 0));
		this.text_color = window.GetProperty("PL.TEXT.COLOR", this.text_color);
		this.folder_color = window.GetProperty("PL.FOLDER.COLOR", this.text_color);
		this.colours_background = window.GetProperty("PL.BACKGROUND.COLOR", this.colours_background );
		this.colours_highlight = window.GetProperty("PL.HIGHLIGHT.COLOR", this.text_color);
		this.selection_color = window.GetProperty("PL.SELECTION.COLOR", RGB(62, 87, 109));
		this.fontSize_value = window.GetProperty("PL.FONTSIZE.VALUE", 12);
		this.openPLclick = window.GetProperty("PL.PLCLICK.BOOL", 0);
		this.delOption = window.GetProperty("PL.DELOPTION.BOOL", 1);
		this.activeSongOption = window.GetProperty("PL.ACTIVESONG.BOOL", 1);
		if (this.activeSongOption == 0) this.off = 5; else this.off = 35;
		this.activeSong_color = window.GetProperty("PL.ACTIVESONG.COLOR", this.text_color);
		this.folderIcon_color = window.GetProperty("PL.FOLDERICON.COLOR", this.text_color);
		this.foldertext_weight = window.GetProperty("PL.FOLDERTEXT.WEIGHT", 1);
		this.headerline_color = window.GetProperty("PL.HEADERLINE.COLOR", RGB(255, 0, 0));
	}

	this.font_changed = function () {
		this.fonts.pl = JSON.parse(window.IsDefaultUI ? window.GetFontDUI(3) : window.GetFontCUI(0)).Name;
		this.fonts.folder = JSON.parse(window.IsDefaultUI ? window.GetFontDUI(2) : window.GetFontCUI(1)).Name;
		this.fonts_playlist = JSON.stringify({ Name: this.fonts.pl, Size: _scale(this.fontSize_value) });
		this.fonts_folder = JSON.stringify({ Name: this.fonts.folder, Size: _scale(this.fontSize_value) });
		this.fonts_folder_bold = JSON.stringify({ Name: this.fonts.folder, Weight: DWRITE_FONT_WEIGHT_BOLD, Size: _scale(this.fontSize_value) });
		this.fonts.awesome = JSON.stringify({ Name: 'FontAwesome', Weight: DWRITE_FONT_WEIGHT_BOLD, Size: _scale(this.fontSize_value) });
		this.row_height = _scale(this.fontSize_value + 4);
	} 

	this.colours_def = function () {
		if (window.IsDefaultUI) {
			this.colours_background = window.GetColourDUI(1);
			this.text_color = window.GetColourDUI(0);
			this.colours_highlight = window.GetColourDUI(2);
		} else {
			this.colours_background = window.GetColourCUI(3);
			this.text_color = window.GetColourCUI(0);
			this.colours_highlight = blendColours(this.colours_text, this.colours_background, 0.4);
		}
	}

	this.update = function () {
		this.colours_def();
		this.getStoredValues();
		this.font_changed();
		this.dragDrop = false;
		this.btnDown = false;
		this.data = this.getData();
		if (this.old_offset != 0) this.offset = this.old_offset; else this.offset = 0;
		this.index = 0;
		this.foldCount = 0;
		this.getFileData();
		if (this.bgpic) this.setBkgroundImg();
		this.countFold();
		this.cleanup();
		window.Repaint();
	}

	this.cleanup = function () {
		var ind = 0;
		this.display = [];
		for (i = 0; i < this.data.length; i++) {
			if (this.data[i].lvl == '0') {  // starting point i will loop the lvl 1 or 2 below 
				this.data[i].position = ind;
				ind++;
				this.display.push(this.data[i]); // if it's lvl 0 then it has to be displayed so i'm pushing it into the display array
				if (this.data[i].pl == '0' && this.data[i].foldState == '1') { // if this is a lvl 0 folder and it's open
					for (j = 0; j < this.data.length; j++) { // loop to check if this folder has sub items or sub folders
						if (this.data[j].fold == this.data[i].name) {
							this.data[j].position = 1000 + (i * 100) + j;
							this.display.push(this.data[j]);
							if (this.data[j].pl == '0' && this.data[j].foldState == '1') { // if there is a lvl 1 sub folder and it's opened
								for (k = 0; k < this.data.length; k++) { // same loop as above for the lvl 2 items
									if (this.data[k].fold == this.data[j].name) {
										this.data[k].position = 2000 + (i * 100) + (j * 10) + k;
										this.display.push(this.data[k]);
									}
								}
							}
						}
					}
				}
			}
			else {
				if (this.data[_.findIndex(this.data, { name: this.data[i].fold })].foldState == '0') {
					this.data[i].position = 50000 + i;
				}
			}
		}
		this.data.sort(dynamicSort("position"));
		this.items = this.display.length;
		this.save_status();
	}

	this.calc_text_width = function (text) {
		return utils.CalcTextWidth(text, this.fonts.name,  _scale(this.fontSize_value));
	}
	this.reset = function () {
		this.old_offset = this.offset; // to keep offset position when updating when focus change
		this.items = 0;
		this.data = [];
	}
	this.searchChars = function (txt) {
		if (txt.length > 2) {
			var id = "";
			for (var i = 0; i < this.display.length; i++) {
				if (this.display[i].name.toLowerCase().substring(0, txt.length) == txt.toLowerCase()) {
					id = this.display[i].id;
					break;
				}
			}
			if (id) {
				var index = _.findIndex(this.display, { id: id });
				this.setSel(index);
				if (this.display[index].pl ==1)
				plman.ActivePlaylist = plman.FindByGUID(this.display[index].id);
				this.searchbox.bordercolor = RGB(0, 102, 0);
				window.repaint();
			}
			else {
				this.searchbox.bordercolor = RGB(255, 0, 0);
				window.repaint();
			}
        }
	}

	this.searchbox = function () {
		this.inputbox = new oInputbox(100, 30, "", "", this.text_color, this.colours_background, RGB(255, 0, 0), this.colours_background, "");
		this.inputbox.setSize(100, 30, g_fsize);
		this.inputboxID = 1;
		this.inputbox.on_focus(true);
		this.inputbox.edit = true;
		this.inputbox.Cpos = this.inputbox.text.length;
		this.inputbox.anchor = this.inputbox.Cpos;
		this.inputbox.SelBegin = this.inputbox.Cpos;
		this.inputbox.SelEnd = this.inputbox.Cpos;
		if (!cInputbox.timer_cursor) {
			this.inputbox.resetCursorTimer();
		}
		this.inputbox.dblclk = true;
		this.inputbox.SelBegin = 0;
		this.inputbox.SelEnd = this.inputbox.text.length;
		this.inputbox.text_selected = this.inputbox.text;
		this.inputbox.select = true;

		window.repaint();
	}
    
	
	function showHelp() {
		var str = window.Name + "\n \n";
		str = str + "Known limitations : \n \n";
		str = str + " - Only 2 levels or sub-levels of folder \n"
		str = str + " - Doesnt allow duplicate name for folder \n"
		str = str + " - No multiple selection allowed \n"
		str = str + " - Can't unselect a folder/playlist \n"
		str = str + "\n"
		str = str + "List of functionalities : \n \n";
		str = str + " - Allow duplicate names for playlist \n"
		str = str + " - Drag & drop within the panel for reordering & folder management \n"
		str = str + " - Drag & drop from other panels to feed playlists \n"
		str = str + " - Drag & drop functionalities are also available in the right click menu\n"
		str = str + " - Right click menu in the playlist area is contextual \n"
		str = str + " - Right click menu in the header area is for customization \n"
		str = str + " - Create/Edit/rename/delete existing playlist and autoplaylists\n"
		str = str + " - Sort a folder content or the root (asc & desc) \n"
		str = str + " - Switch from # of playlists to (Size & # of playlists) by clicking on the upper right button\n"
		str = str + " - Auto-Collapse menu allows to have only one folder open (all the other ones will close). ! Works on the first folder level ! \n"
		str = str + " - Playlist in which the current track playing is identified by a note on the left or a different color \n"
		str = str + " - Active Playlist is identified by a specific rectangle \n"
		str = str + " - Push + or - buttons to modify the position of the selected folder/playlist \n"
		str = str + " - Folder font is the 'label' font using CUI or 'list' font using DUI, font can be set to bold in the option \n"
		str = str + " - Playlist font is the 'items' font using CUI or 'playlist' font using DUI  \n"
		str = str + " - Only the font name will be changed, not the size of the style that can be set in the panel using options (only folder style)  \n"
		str = str + "\n"
		str = str + "Navigation options : \n \n";
		str = str + " - To open a playlist use either a single or double click (parameter based) or the enter key\n"
		str = str + " - To open or close a folder use either a Double click or the left/right arrows\n"
		str = str + " - Mouse wheel, up and down buttons to navigate through the list \n"
		str = str + " - Page up/down as well as end/beg. keys to navigate through the list \n"

		utils.ShowPopupMessage(str, "Help");
	}

	
	this.y = 0; // top of the panel
	this.ylist = 33; // top of the list after the header
	this.index = 0;
	this.offset = 0;
	this.old_offset = 0; // to recall position when playlist has changed and need to recalculate (to avoid the list systematically going on the top)
	this.items = 0;
	this.ctrl = false;
//	this.shift = false;
	this.fonts_sizes = [9, 10, 12, 14, 16, 20];
	this.off = 35;
	this.fonts = {};
	this.list_objects = [];
	this.text_objects = [];
	this.list_objects.push(this);
	this.up_btn = new _sbut(chars.up, this.off, this.y, _scale(12), _scale(12), _.bind(function () { return this.offset > 0; }, this), _.bind(function () { this.wheel(1); }, this));
	this.down_btn = new _sbut(chars.down,  this.off, this.y, _scale(12), _scale(12), _.bind(function () { return this.offset < this.items - this.rows; }, this), _.bind(function () { this.wheel(-1); }, this));
	this.buttons_numb = new _sbut(showNumb ? chars.weight : chars.number, this.w, this.y, 40, 30, _.bind(function () { return true; }, this), _.bind(function () { showNumb = !showNumb; window.Repaint(); }, this));
	this.but_help = new _sbut("?", this.panel_w - 45, 0, 45, 30, _.bind(function () { return true; }, this), _.bind(function () { showHelp(); }, this));
	//this.inputSearchBut = new _sbut("Input", 45, 0, 100, 30, _.bind(function () { return true; }, this), _.bind(function () { this.searchbox(); }, this));
}

function on_char(code) {
	if (pl_organizer.inputboxID == 1) {
		pl_organizer.inputbox.on_char(code);
		pl_organizer.searchChars(pl_organizer.inputbox.text);
	}
}


//// TOOLS ///////
Array.prototype.move = function (from, to) {
	var i, tmp;
	from = parseInt(from, 10);
	to = parseInt(to, 10);
	if (from !== to && 0 <= from && from <= this.length && 0 <= to && to <= this.length) {
		tmp = this[from];
		if (from < to) {
			for (i = from; i <= to; i++) {
				this[i] = this[i + 1];
			}
		}
		else {
			for (i = from; i >= to; i--) { // >=
				this[i] = this[i - 1];
			}
		}
		this[to] = tmp;
	}
	return this[to < 0 ? 0 : to].id;
}

function dynamicSort(property) { // convert into numbers with the +
	var sortOrder = 1;
	if (property[0] === "-") {
		sortOrder = -1;
		property = property.substr(1);
	}
	return function (a, b) {
		var result = (+a[property] < +b[property]) ? -1 : (+a[property] > +b[property]) ? 1 : 0;
		return result * sortOrder;
	}
}

function niceBytes(x) {
	var l = 0, n = parseInt(x, 10) || 0;
	while (n >= 1024 && ++l) {
		n = n / 1024;
	}
	return ( n.toFixed(n < 10 && l > 0 ? 2 : 1) + ' ' + units[l]  );
}

function millisecondsToStr(sec) {
	var weeks = Math.floor(sec / 604800),
		days = Math.floor((sec %= 604800) / 86400),
		hours = Math.floor((sec %= 86400) / 3600),
		minutes = Math.floor((sec %= 3600) / 60),
		seconds = sec % 60;

	if (days || hours || seconds || minutes) {
		return (weeks ? weeks + "w " : "") +
			(days ? days + "d " : "") +
			(hours ? hours + "h " : "") +
			(minutes ? minutes + ":" : "") +
			Number(seconds).toFixed(0) + "s";
	}

	return "< 1s";
}


function _sbut(ch, x, y, w, h, v, fn) {
	this.paint = function (gr, colour, ch) {
		if (this.v()) {
			if (!ch) ch = this.ch;
			gr.WriteText(ch, this.font, colour,this.x, this.y, this.w, this.h, 2, 2);
		}
	}

	this.containsXY = function (x, y) {
		return x > this.x && x < this.x + this.w && y > this.y && y < this.y + this.h && this.v();
	}

	this.move = function (x, y) {
		if (this.containsXY(x, y)) {
			window.SetCursor(IDC_HAND);
			return true;
		}

		return false;
	}

	this.lbtn_up = function (x, y) {
		if (this.containsXY(x, y)) {
			if (this.fn) {
				this.fn(x, y);
			}
			return true;
		}
		return false;
	}

	this.ch = ch;
	this.x = x;
	this.y = y;
	this.w = w;
	this.h = h;
	this.v = v;
	this.fn = fn;
	this.font = JSON.stringify({ Name: 'FontAwesome', Size: h });
}



//TODOS///////
// mettre le fold id instead of name 
// try to replace the display/data arrays into a multi dimensional array
// unselect
/*
Quick fix with the right click at load up generating a crash
font 9 is now available 

*/
